NB. Digital Raster Graphics Utilities
NB. and some unused archive utilities 
NB. mentioned in GIS and J write a hiking book

NB. colors
Ctext=:50 0 150     NB. color for text
Ctrail=:255 255 0   NB. color for trails
Ctless=:140 50 0    NB. color for trail-less routes

NB. default DRG palette
Pmt=:0 : 0
0  Black        0 0 0 
1  White        255 255 255 
2  Blue         0 151 164 
3  Red          203 0 23 
4  Brown        131 66 37 
5  Green        201 234 157 
6  Purple       137 51 128 
7  Yellow       255 234 0 
8  Light Blue   167 226 226 
9  Light Red    255 184 184 
10 Light Purple 218 179 214 
11 Light Grey   209 209 209 
12 Light Brown  207 164 142
)

Pm=:".@(15&}.) ;._2 Pmt

NB. coordinates 
]h48_co =: ,0 0.125 +/_73.875 44

NB. J array read and write
ja_read=: 3!:2@:fread
ja_write=: 3!:1@[ fwrite ]

NB. constant extension
conext=:{.,],{:
conext2=:conext"_1@:conext

NB. round
rnd=:<.@(0.5&+)

NB. adjust coordinate according to 0-to-1 selection
n_adj_co=:4 : ',(2{.y)+"1 (2 2$x)*"1 --/2 2$y'

NB. subimage according to 0-to-1 selection
n_adj_b=: 4 : 0
'a b'=.rnd _1 1*"1 (|."1 ]2 2$x)*"1]2{.$y
a}.b{.y
)

NB. used to shadow text
grow=:3 : 0
n=.(1|.y)+._1|.y
m1=.1|."1 y
n=.n+.m1+.(1|.m1)+._1|.m1
m1=._1|."1 y
n+.m1+.(1|.m1)+._1|.m1
)

NB. shadow text color some number of pixels
textedge=:3 : 0
1 textedge y
:
m=.(Ctext{a.) -:"1 y{a.
n=.grow^:x m
m=.n*.-.m
(y*-.m)+m*255
)

NB. toTs; courtesy of Raul Miller
toTS=: 0 ". e.&(~.":i.10)`(' '&,:)}

NB. leading number in text
headnum=:[: ".@, (0 i.~ ] e. '0123456789.-'"_){.]

NB. cut text on left argument, disgarding text
cuts=: 4 : '(x E. y) <@((#x)&}.) ;.1 y'

NB. trackpoints plus! in a lap
NB. result: hours_from_start latitude longitude altitude(km) Distance_fromStart(m) 
tpx_in_lap=:3 : 0
y=.('<Trackpoint>' E. y)<;.1 y
y=.'<Time>'&cuts&> y
z0=.,/(i.&'<'{.]) &> y
y=.'<LatitudeDegrees>'&cuts&> y
z=.,headnum &> y
y=.'<LongitudeDegrees>'&cuts&> y
z=.z,.,headnum &> y
y=.'<AltitudeMeters>'&cuts&> y
z=.z,.,headnum &> y
y=.'<DistanceMeters>'&cuts&> y
(3600000%~(-{.)tsrep toTS z0),. z,.,0.0006214*headnum &> y
)

