NB. Example script to create a enhanced map for 
NB. Witness the Forever Wild
NB. used by GPS and J Propel an Adirondack Hiking Guide
NB. Cliff Reiter, April 2008
NB. 
NB. adirondack trek drawer
NB. trek 175 Macomb & Dix
NB. 2007_08c

pathi=:'/gps_j_hike/'   NB. default path; modify as necessary
require pathi,'draw_treks_hike.ijs'
require pathi,'lalo_hike.ijs'
require pathi,'drg_util.ijs'

NB. read hike trackpoint data: 
NB. time, latitude, longitude, altitude, cumulative distance
$tpx0=:ja_read pathi,'hike175.ja'
't0 la0 lo0 a0 d0'=:|:tpx0

NB. use given times
ts=:t0

NB. model distance via trek_d
$ds=:trek_d tpx=:tpx0

NB. model cumulative ascent
cum_alt 3{|:tpx

]i=.ds I. (i.@>.,]){:ds   NB. position of mile markers
tps=:(la0),.lo0           NB. track points
tps0=:(n0=:440){.tps      NB. first segment on trail
tps1=:(n1=:2040){.n0}.tps NB. trail-less segment
tps2=:(n0+n1)}.tps        NB. last segment on trail

TXpt=:i{tps               NB. mile marker latitude-longitude
]TX0=:(4j1 ":,.i{ds),"1 'mi'   NB. mile marker text
]TX1=:(4j1 ":,.i{ts),"1 'hr'   NB. mile marker times

dxdy=:_10 _5              NB. map registration offset

NB. read raw topo map
$a=:raw_read_image pathi,'h48.png'  

NB. view the relevant portion
$view_image b=:(nc=:0.3 0.1 0.9 0.7) n_adj_b a 

NB. show the map (exceeds most screens)
(nc n_adj_co h48_co) 'lc' show_raw_map b

NB. draw three segments using appropriate colors
dxdy(Ctrail;5 0) draw_trek tps0
dxdy(Ctless;5 0) draw_trek tps1
dxdy(Ctrail;5 0) draw_trek tps2

NB. draw mile points
dxdy (Ctext;15 0) draw_trek"2 ,:~"1  TXpt

NB. add mile/time text to map; some on right, some on left
gltextcolor '' [glrgb Ctext
15 20 '"Lucida Console" 16 bold' draw_text (nn{.TX0) (nn=:8){.TXpt  
15 _5 '"Lucida Console" 16 bold' draw_text (nn{.TX1) nn{.TXpt  
_150 30 '"Lucida Console" 16 bold' draw_text (nn}.TX0) nn}.TXpt  
_150 5 '"Lucida Console" 16 bold' draw_text (nn}.TX1) nn}.TXpt  
wd 'reset;'

NB. shadow text for visibility
view_image c=:2 textedge trek_z

NB. get palette using DRG up front
pal=:~.Pm,~.,/trek_z

NB. indices into palette
c=:pal i. c

NB. save file
(pal;c) write_image pathi,'dw02.png'
